Index: /trunk/src/sh_mail.c
===================================================================
--- /trunk/src/sh_mail.c	(revision 584)
+++ /trunk/src/sh_mail.c	(revision 1)
@@ -34,8 +34,15 @@
 #if defined(SH_WITH_MAIL)
 
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
+#else
+#include <time.h>
 #endif
-#include <time.h>
+#endif
+
 
 #ifdef HAVE_MEMORY_H
@@ -51,9 +58,4 @@
 #include "sh_fifo.h"
 #include "sh_tools.h"
-#include "sh_pthread.h"
-#include "sh_filter.h"
-#include "sh_mail_int.h"
-#include "sh_nmail.h"
-#include "sh_ipvx.h"
 
 #undef  FIL__
@@ -62,6 +64,19 @@
 #undef  BAD
 
-static int failedMail = S_FALSE;
-
+static int failedMail = SL_FALSE;
+
+/* MX Resolver Struct
+ */
+typedef struct mx_ {
+  int    pref;
+  char * address;
+} mx;
+
+typedef struct dnsrep_ {
+  int    count;
+  mx   * reply;
+} dnsrep;
+
+static int free_mx (dnsrep * answers);
 static dnsrep * return_mx (char *domain);
 
@@ -78,5 +93,5 @@
 static mail_trail_type * mail_trail = NULL;
 
-int sh_mail_sigverify (const char * s)
+int sh_mail_sigverify (char * s)
 {
   SL_TICKET  fd;
@@ -109,5 +124,5 @@
       _exit (EXIT_FAILURE);
     }
-  if ( SL_ISERROR(fd = sl_open_read (FIL__, __LINE__, s, SL_NOPRIV)))
+  if ( SL_ISERROR(fd = sl_open_read (s, SL_NOPRIV)))
     {
       fprintf(stderr, _("Could not open file %s\n"), s);
@@ -115,6 +130,6 @@
     }
 
-  buf     = SH_ALLOC( (size_t)(SH_MSG_BUF+SH_BUFSIZE+1));
-  bufc    = SH_ALLOC( (size_t)(SH_MSG_BUF+SH_MAXBUF+1));
+  buf     = SH_ALLOC( (size_t)(SH_BUFSIZE+1));
+  bufc    = SH_ALLOC( (size_t)(SH_MAXBUF+1));
 
   while (1 == 1)
@@ -128,5 +143,5 @@
 			     sizeof("-----BEGIN MESSAGE-----")-1)) 
 	{
-	  (void) sh_unix_getline (fd, buf, SH_MSG_BUF+SH_BUFSIZE);
+	  (void) sh_unix_getline (fd, buf, SH_BUFSIZE);
 	  if (buf[0] == '\0')
 	    {
@@ -147,5 +162,5 @@
       while (1 == 1)
 	{
-	  (void) sh_unix_getline (fd, buf, SH_MSG_BUF+SH_BUFSIZE);
+	  (void) sh_unix_getline (fd, buf, SH_BUFSIZE);
 	  if (0 == sl_strncmp(buf, _("-----BEGIN SIGNATURE-----"),
 			      sizeof("-----BEGIN SIGNATURE-----")-1))
@@ -153,13 +168,13 @@
 	  if (buf[0] == '\0') 
 	    _exit (EXIT_FAILURE);
-	  (void) sh_util_compress(bufc, buf, SH_MSG_BUF+SH_MAXBUF-KEY_LEN);
+	  (void) sh_util_compress(bufc, buf, SH_MAXBUF-KEY_LEN);
 	}
       
       /* get signature and number 
        */
-      (void) sh_unix_getline (fd, key, (int)sizeof(key));
+      (void) sh_unix_getline (fd, key, (int)(  sizeof(key)-1));
       key[KEY_LEN] = '\0';
 
-      (void) sh_unix_getline (fd, number, (int)sizeof(number));
+      (void) sh_unix_getline (fd, number, (int)(sizeof(number)-1));
       number[(2*SH_MINIBUF) - 2]   = '\0';
       numsig = atol (number);
@@ -181,5 +196,5 @@
 	  if (numsig > 0)
 	    {
-	      fprintf (stderr, "%s",_("ERROR (no key -- cannot check)\n"));
+	      fprintf (stderr, _("ERROR (no key -- cannot check)\n"));
 	      continue;
 	    }
@@ -195,5 +210,5 @@
       else if (numsig == 0)
 	{
-	  fprintf (stderr, "%s",_("ERROR (repeated audit trail)\n"));
+	  fprintf (stderr, _("ERROR (repeated audit trail)\n"));
 	  continue;
 	}
@@ -204,10 +219,8 @@
 	  sh_util_encode(key, bufc, 1, 'A');
 	  (void) sl_strlcpy (mail_trail_ptr->trail_key, key, KEY_LEN+1);
-	  fprintf (stderr, "%s",_("(unchecked)\n"));
+	  fprintf (stderr, _("(unchecked)\n"));
 	}
       else
 	{
-	  char sigbuf[KEYBUF_SIZE];
-
 	  /* iterate key
 	   */
@@ -215,23 +228,20 @@
 	  for (i = 0; i < numsig; ++i) 
 	    {
-	      char hashbuf[KEYBUF_SIZE];
 	      (void) sl_strlcpy (key2, 
-				 sh_tiger_hash (key2, TIGER_DATA, KEY_LEN,
-						hashbuf, sizeof(hashbuf)), 
+				 sh_tiger_hash (key2, TIGER_DATA, KEY_LEN), 
 				 KEY_LEN+1);
 	    }
 	  
-	  theSig = sh_util_siggen (key2, bufc, sl_strlen(bufc), 
-				   sigbuf, sizeof(sigbuf));
-
+
+	  theSig = sh_util_siggen (key2, bufc, sl_strlen(bufc));
 	  if (sl_strncmp (key, 
 			  theSig,
 			  KEY_LEN) != 0) 
 	    {
-	      fprintf (stderr, "%s",_("(FAILED)\n"));
+	      fprintf (stderr, _("(FAILED)\n"));
 	    } 
 	  else 
 	    { 
-	      fprintf (stderr, "%s",_("(passed)\n"));
+	      fprintf (stderr, _("(passed)\n"));
 	    }
 
@@ -243,5 +253,285 @@
 }
 
-int sh_mail_setNum (const char * str)
+#define SH_FILT_NUM 32
+#define SH_FILT_OR  0
+#define SH_FILT_AND 1
+#define SH_FILT_NOT 2
+#define SH_FILT_INIT { 0, { NULL }, 0, { NULL }, 0, { NULL }}
+
+typedef struct _sh_filter_type
+{
+  int      for_c;
+  char   * for_v[SH_FILT_NUM];
+  int      fand_c;
+  char   * fand_v[SH_FILT_NUM];
+  int      fnot_c;
+  char   * fnot_v[SH_FILT_NUM];
+
+} sh_filter_type;
+
+static
+int sh_filter_filteradd (char * argstring, sh_filter_type * filter, int ftype)
+{
+  int     i = 0;
+  int     flag = 0;
+  size_t  s;
+
+  char  * dup;
+  char  * p;
+  char  * end;
+  int   * ntok;
+  char ** stok;
+
+  SL_ENTER(_("sh_filter_filteradd"));
+
+  if (NULL == argstring)
+    {
+      SL_RETURN((-1), _("sh_filter_filteradd")); 
+    }
+
+  if (ftype == SH_FILT_OR) {
+    ntok = &(filter->for_c);
+    stok = filter->for_v;
+  }
+  else if (ftype == SH_FILT_AND) {
+    ntok = &(filter->fand_c);
+    stok = filter->fand_v;
+  }
+  else if (ftype == SH_FILT_NOT) {
+    ntok = &(filter->fnot_c);
+    stok = filter->fnot_v;
+  }
+  else {
+    SL_RETURN((-1), _("sh_filter_filteradd")); 
+  }
+
+  *ntok = 0;
+
+  dup = sh_util_strdup(argstring);
+  p   = dup;
+
+  do
+    {
+      while (*p == ',' || *p == ' ' || *p == '\t')
+	++p;
+      if (*p == '\0')
+	break;
+
+      end = p; ++end;
+      if (*end == '\0')
+	break;
+
+      if (*p == '\'')
+	{
+	  ++p; end = p; ++end;
+	  if (*p == '\0' || *end == '\0')
+	    break;
+	  while (*end != '\0' && *end != '\'')
+	    ++end;
+	}
+      else if (*p == '"')
+	{
+	  ++p; end = p; ++end;
+	  if (*p == '\0' || *end == '\0')
+	    break;
+	  while (*end != '\0' && *end != '"')
+	    ++end;
+	}
+      else
+	{
+	  while (*end != '\0' && *end != ',' && *end != ' ' && *end != '\t')
+	    ++end;
+	}
+      if (*end == '\0')
+	flag = 1;
+      else
+	*end = '\0';
+
+      s = strlen(p) + 1;
+      if (stok[i] != NULL)
+	SH_FREE(stok[i]);
+      stok[i] = SH_ALLOC(s);
+      (void) sl_strlcpy(stok[i], p, s);
+
+      p = end; ++p;
+
+      ++i;
+      if (i == SH_FILT_NUM)
+	break;
+    }
+  while (p != NULL && *p != '\0' && flag == 0);
+
+  *ntok = i;
+  SH_FREE(dup);
+
+  SL_RETURN (0, _("sh_filter_filteradd"));
+}
+
+/*
+ * -- check filters
+ */
+static 
+int sh_filter_filter (char * message, sh_filter_type * filter)
+{
+  int i;
+  int j = 0;
+
+  SL_ENTER(_("sh_mail_filter"));
+
+  /* Presence of any of these keywords prevents execution.
+   */
+  if (filter->fnot_c > 0)
+    {
+      for (i = 0; i < filter->fnot_c; ++i)
+	{
+	  if (NULL != sl_strstr(message, filter->fnot_v[i]))
+	    {
+	      SL_RETURN ((-1), _("sh_filter_filter"));
+	    }
+	}
+    }
+
+  /* Presence of all of these keywords is required for execution.
+   */
+  if (filter->fand_c > 0)
+    {
+      j = 0;
+
+      for (i = 0; i < filter->fand_c; ++i)
+	if (NULL != sl_strstr(message, filter->fand_v[i]))
+	  ++j;
+
+      if (j != filter->fand_c)
+	{
+	  SL_RETURN ((-1), _("sh_filter_filter"));
+	}
+    }
+
+  /* Presence of at least one of these keywords is required for execution.
+   */
+  if (filter->for_c > 0)
+    {
+      for (i = 0; i < filter->for_c; ++i)
+	{
+	  if (NULL != sl_strstr(message, filter->for_v[i]))
+	    {
+	      goto isok;
+	    }
+	}
+      SL_RETURN ((-1), _("sh_filter_filter"));
+    }
+
+ isok:
+  SL_RETURN ((0), _("sh_filter_filter"));
+}
+
+
+static sh_filter_type mail_filter = SH_FILT_INIT;
+
+/*
+ * -- add keywords to the OR filter
+ */
+int sh_mail_add_or (char * str)
+{
+  return (sh_filter_filteradd (str, &(mail_filter), SH_FILT_OR));
+}
+
+/*
+ * -- add keywords to the AND filter
+ */
+int sh_mail_add_and (char * str)
+{
+  return (sh_filter_filteradd (str, &(mail_filter), SH_FILT_AND));
+}
+
+/*
+ * -- add keywords to the NOT filter
+ */
+int sh_mail_add_not (char * str)
+{
+  return (sh_filter_filteradd (str, &(mail_filter), SH_FILT_NOT));
+}
+
+
+static char * address_list[8] = { 
+  NULL, NULL, NULL, NULL, 
+  NULL, NULL, NULL, NULL 
+};
+
+static   int   address_num = 0;
+static   int   address_num_compiled = 0;
+static   int   setaddress_compiled = S_FALSE;
+
+void reset_count_dev_mail(void)
+{
+  /* if not, then we still have the compiled-in address (if any), so we
+   * don' touch them
+   */
+  if (address_num_compiled == -99)
+    address_num = 0;
+  return;
+}
+
+int sh_mail_setaddress (char * address)
+{
+  char     *     p;
+
+  SL_ENTER(_("sh_mail_setaddress"));
+  
+  if (0 == strcmp(address, _("NULL")))
+    SL_RETURN ( (0), _("sh_mail_setaddress"));
+    
+  if (address != NULL && address_num < (2 * SH_PATHBUF / 64 )) 
+    {
+      if (address_num < (SH_PATHBUF / 64 ))
+	p = &sh.srvmail.name[address_num*64];
+      else
+	p = &sh.srvmail.alt[address_num*64];
+
+      (void) sl_strlcpy (p, address, 64);
+      
+      if ((p == NULL) || ( sl_strlen(address) != sl_strlen(p)))
+	{
+	  memset(p, (int)'\0', 64);
+	  SL_RETURN ( (-1), _("sh_mail_setaddress"));
+	}
+      address_list[address_num] = p;
+#if 0
+      if (!sl_is_suid())
+	{
+	  TPT(( 0, FIL__, __LINE__, _("msg=<address_list[%d] = %s>\n"), 
+		address_num, address_list[address_num]));
+	}
+#endif
+      if (setaddress_compiled == S_TRUE)
+	{
+	  ++address_num;
+	  ++address_num_compiled;
+	}
+      else
+	{
+	  if (address_num == address_num_compiled)
+	    {
+	      address_num = 0;
+	      address_num_compiled = -99;
+	    }
+	  ++address_num;
+	}
+      SL_RETURN ( (0), _("sh_mail_setaddress"));
+    }
+  SL_RETURN ( (-1), _("sh_mail_setaddress"));
+}
+
+int sh_mail_setaddress_int (char * address)
+{
+  int i;
+  SL_ENTER(_("sh_mail_setaddress_int"));
+  setaddress_compiled = S_TRUE;
+  i = sh_mail_setaddress(address);
+  setaddress_compiled = S_FALSE;
+  SL_RETURN(i, _("sh_mail_setaddress_int"));
+}
+
+int sh_mail_setNum (char * str)
 {
   int i = atoi (str);
@@ -257,11 +547,11 @@
 
 
-int sh_mail_all_in_one = S_FALSE;
-
-int sh_mail_setFlag (const char * str)
+static int all_in_one = S_FALSE;
+
+int sh_mail_setFlag (char * str)
 {
   int i;
   SL_ENTER(_("sh_mail_setFlag"));
-  i = sh_util_flagval(str, &sh_mail_all_in_one);
+  i = sh_util_flagval(str, &all_in_one);
   SL_RETURN(i, _("sh_mail_setFlag"));
 }
@@ -269,5 +559,5 @@
 static char * mail_subject = NULL;
 
-int set_mail_subject (const char * str)
+int set_mail_subject (char * str)
 {
   SL_ENTER(_("set_mail_subject"));
@@ -288,7 +578,6 @@
 }
 
-SH_MUTEX_INIT(mutex_fifo_mail, PTHREAD_MUTEX_INITIALIZER);
-
-SH_FIFO * fifo_mail = NULL;
+
+static SH_FIFO * fifo_mail = NULL;
 
 static
@@ -303,5 +592,4 @@
     SL_RET0(_("sh_mail_emptystack"));
 
-  SH_MUTEX_LOCK(mutex_fifo_mail);
   while (NULL != (msg = pop_list(fifo_mail)))
     {
@@ -310,5 +598,4 @@
       SH_FREE(msg);
     }
-  SH_MUTEX_UNLOCK(mutex_fifo_mail);
 
   SL_RET0(_("sh_mail_emptystack"));
@@ -317,25 +604,26 @@
 /* insert "\r\n" after each 998 char
  */
-static char * split_string(const char * str);
-
-/* fixes warning: variable âpâ might be clobbered by âlongjmpâ or âvforkâ*/
-static char ** p_dummy;
-
-int sh_mail_pushstack (int severity, const char * msg, const char * alias)
+static char * split_string(char * str);
+
+int sh_mail_pushstack (/*@null@*/char * msg)
 {
   char * p;
-  volatile int    retval = 0;
+  int    retval = 0;
   int    status;
 
   SL_ENTER(_("sh_mail_pushstack"));
 
-  if (msg == NULL || failedMail == S_TRUE /* || sh.srvmail.name[0] == '\0' */) 
+  if (msg == NULL || failedMail == SL_TRUE || sh.srvmail.name[0] == '\0') 
     SL_RETURN((0), (_("sh_mail_pushstack")));
 
+  if (0 != sh_filter_filter(msg, &mail_filter))
+    SL_RETURN((0), (_("sh_mail_pushstack")));
+
+#if 0
+  if (msg != NULL && sl_strlen(msg) > 998)  /* RFC 2822 */
+    msg[998] = '\0';
+#endif
+
   p = split_string(msg);
-  /* fixes "variable âpâ might be clobbered by âlongjmpâ or âvforkâ" */
-  p_dummy = &p;
-
-  SH_MUTEX_LOCK(mutex_fifo_mail);
 
   if (fifo_mail == NULL)
@@ -344,7 +632,6 @@
       fifo_init(fifo_mail);
     }
-  status = push_list (fifo_mail, p, severity, alias);
-  SH_MUTEX_UNLOCK(mutex_fifo_mail);
-
+
+  status = push_list (fifo_mail, p);
   if (status >= 0)
     ++sh.mailNum.alarm_last;
@@ -354,6 +641,6 @@
   if (sh.mailNum.alarm_last >= sh.mailNum.alarm_interval)
     {
-      BREAKEXIT(sh_nmail_flush);
-      retval = sh_nmail_flush ();
+      BREAKEXIT(sh_mail_msg);
+      retval = sh_mail_msg (NULL);
     }
 
@@ -366,9 +653,9 @@
 /* The mailer.
  */
-static int sh_mail_end_conn (FILE * connfile, int fd);
-static FILE * sh_mail_start_conn (struct alias * address, int * fd, int * anum);
+static int sh_mail_end_conn (FILE * connfile);
+static FILE * sh_mail_start_conn (int aFlag);
 
 static
-void sh_mail_get_subject(const char * message,
+void sh_mail_get_subject(char * message,
 			 char * mheader, size_t len)
 {
@@ -384,5 +671,4 @@
   char * mptr;
   char   sev[8];
-  char * msg;
 
   SL_ENTER(_("sh_mail_get_subject"));
@@ -401,7 +687,5 @@
   /* fast forward to the important part
    */
-  msg  = sh_util_strdup(message);
-
-  mptr = sl_strstr(msg, _("msg="));
+  mptr = sl_strstr(message, _("msg="));
   if (mptr)
     {
@@ -410,7 +694,7 @@
     }
   else
-    rep_serv_tab[2].data_str   = msg;
-
-  mptr = sl_strstr(msg, _("sev="));
+    rep_serv_tab[2].data_str   = message;
+
+  mptr = sl_strstr(message, _("sev="));
   if (mptr)
     {
@@ -424,5 +708,5 @@
   else
     {
-      mptr = msg;
+      mptr = message;
       sev[0] = *mptr; ++mptr;
       sev[1] = *mptr; ++mptr;
@@ -447,120 +731,103 @@
   (void) sl_strlcat(mheader, p, len);
   SH_FREE(p);
-  SH_FREE(msg);
   SL_RET0(_("sh_mail_get_subject"));
 }
 
-sh_string * sh_mail_signature_block (sh_string  * sigMsg, char * recipient,
-				     char * bufcompress)
-{
-  time_t         id_audit;
-  char         * theSig;
-  char ibuf[80];
-  unsigned int count;
-
-  /* ------ signature block ------------------------------------ */
-  
-  sigMsg = sh_string_add_from_char(sigMsg, 
-				   _("-----BEGIN SIGNATURE-----\r\n"));
-  
-  count  = sh_nmail_get_mailkey (recipient, skey->mailkey_new, KEY_LEN+1,
-				 &id_audit);
-  
-  if (count != 0)
-    {
-      char sigbuf[KEYBUF_SIZE];
-      
-      /* Sign the message with the signature key.
-       */
-      theSig = sh_util_siggen (skey->mailkey_new, 
-			       bufcompress, sl_strlen(bufcompress),
-			       sigbuf, sizeof(sigbuf));
-      sigMsg = sh_string_add_from_char(sigMsg, theSig);
-    }
-  else
-    {
-       /* reveal first signature key
-       */
-      /* flawfinder: ignore */
-      (void) sl_strlcpy(skey->crypt, skey->mailkey_new, KEY_LEN+1); 
-      
-      BREAKEXIT(sh_util_encode);
-      /* flawfinder: ignore */
-      sh_util_encode(skey->crypt, bufcompress, 0, 'A');
-      
-      /* flawfinder: ignore */
-      sigMsg     = sh_string_add_from_char(sigMsg, skey->crypt);
-      
-      /* flawfinder: ignore */
-      memset (skey->crypt, 0, KEY_LEN);
-    }
-
-    sigMsg     = sh_string_add_from_char(sigMsg, "\r\n");
-
-    sl_snprintf(ibuf, sizeof(ibuf), _("%06u %010lu::%s\r\n"),
-		count, (unsigned long) id_audit, sh.host.name);
-
-    sigMsg     = sh_string_add_from_char(sigMsg, ibuf);
-    sigMsg     = sh_string_add_from_char(sigMsg, _("-----END MESSAGE-----"));
-
-    return sigMsg;
-}
-
-int sh_mail_msg (const char * message)
+
+#if defined(HAVE_MLOCK) && !defined(HAVE_BROKEN_MLOCK)
+#include <sys/mman.h>
+#endif
+
+static char * sh_mail_realloc (char * inbuf, size_t * insize, size_t increase)
+{
+  size_t newsize = (*insize) + increase + 1;
+  char * outbuf;
+
+  SL_ENTER(_("sh_mail_realloc"));
+
+  outbuf = SH_ALLOC(newsize);
+  MLOCK(outbuf, newsize);
+  (void) sl_strlcpy(outbuf, inbuf, newsize);
+
+  memset (inbuf, 0, (*insize));
+  MUNLOCK(inbuf, (*insize));
+  SH_FREE(inbuf);
+
+  *insize = newsize;
+
+  SL_RETURN( (outbuf), _("sh_mail_realloc"));
+}
+
+int sh_mail_msg (/*@null@*/char * message)
 {
     char         subject[32+32+SH_MINIBUF+2+3+SH_PATHBUF];
     char         mheader[32+32+SH_MINIBUF+2+3];
 
-    sh_string  * mailMsg;
-    sh_string  * compMsg;
-    int          status = 0;
-    volatile int errcount;
+    char       * mailMsg;
+    char       * popMsg;
+    int          status = 0, errcount;
     size_t       wrlen;
-    volatile int retval = -1;  
+    int          i;
+    int          num_popped = 0;
+    int          retval = -1;  
 
     char       * bufcompress;
-    size_t       compressed;
-
     static int   failcount = 0;
+    static int   isfirst   = 1;
+    static int   mailcount = 0;
     FILE       * connfile  = NULL;
 
+    struct  sigaction  old_act;
+    struct  sigaction  new_act;
+
+    static  time_t id_audit  = 0;
     static  time_t fail_time = 0;
     static  time_t success_time = 0;
 
-    int       ma_socket = -1;
-
-    int            address_num = 0;
-    sh_string    * theMsg = NULL;
+    static  int ma_block = 0;
+
+    SH_FIFO * fifo_temp = NULL;
+
+    char    * theSig;
+    char    * theMsg = NULL;
 
     /* #define SH_MAILBUF (256)    */
-#define SH_MAILBUF 4096 
-
-    char      timebuf[81];
+#define SH_MAILBUF (8*4096) 
+
+    size_t    msgbufsize = SH_MAILBUF;
+    size_t    combufsize = SH_MAILBUF;
 
     SL_ENTER(_("sh_mail_msg"));
 
-    /* 
-     * Return if we cannot mail.
+    if (ma_block == 1)
+      SL_RETURN( (0), _("sh_mail_msg"));
+
+    /* Return if we cannot mail.
      */
-    if (failedMail == S_TRUE) 
+    if (failedMail == SL_TRUE) 
       SL_RETURN((-1), _("sh_mail_msg"));
 
-    /*
-     * Final failure, can't mail for SH_MAX_FAIL hours.
-     */
+    if (failedMail == SL_FALSE && address_list[0] == NULL)
+      {
+	TPT((0, FIL__, __LINE__, 
+	     _("msg=<Mail error: no recipient address.>\n")));
+	failedMail = SL_TRUE;
+	SL_RETURN((-1), _("sh_mail_msg"));
+      }
+
     if ( (success_time > 0) && (fail_time > 0) &&
 	 (time(NULL) - success_time) > 3600*SH_MAX_FAIL)
       {
+	ma_block = 1;
 	sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_SRV_FAIL,
-			 _("mail"), 
-			 sh_string_str(all_recipients->recipient));
+			 _("mail"), address_list[0]);
+	ma_block = 0;
 	sh_mail_emptystack();
 	sh.mailNum.alarm_last = 0;
-	failedMail = S_TRUE;
+	failedMail = SL_TRUE;
 	SL_RETURN((-1), _("sh_mail_msg"));
       }
 
-    /*
-     * Try at most every three seconds to mail if there was a failure.
+    /* Try at most each hour.
      */
     if ((fail_time > 0) && (time(NULL) - fail_time) < 3/*600*/)
@@ -568,10 +835,10 @@
 	if (failcount > 3)
 	  {
-	    /* -- Save for later. Changed: done by caller. -- 
-	     *	    sh_nmail_pushstack (severity, message, alias);
+	    /* -- Save for later. -- 
 	     */
+	    sh_mail_pushstack (message);
 	    ++failcount;
 	    
-	    SL_RETURN((-2), _("sh_mail_msg"));
+	    SL_RETURN((-1), _("sh_mail_msg"));
 	  }
 	else
@@ -586,15 +853,19 @@
     fail_time = 0;
 
+    /* -- Polling, empty queue. --
+     */
+    if (message == NULL && sh.mailNum.alarm_last == 0)
+      SL_RETURN((-1), _("sh_mail_msg"));
+
+    /* -- Filtered. --
+     */
+    if (message != NULL && 0 != sh_filter_filter(message, &mail_filter))
+      SL_RETURN((-1), (_("sh_mail_msg")));
+
+
 
     /* ---------  Build complete message. ------------------------ */
 
-    /* Don't flush the queue here, because tag_list doesn't know
-     * how to filter messages. */
-
-    theMsg = sh_string_new_from_lchar(message, sl_strlen(message));
-    if (!theMsg)
-      {
-	SL_RETURN((-1), _("sh_mail_msg"));
-      }
+    theMsg = split_string(message);
 
     /* ---------- Header  ---------------------------------------- */
@@ -603,7 +874,5 @@
       {
 	(void) sl_strlcpy(mheader, _("Subject: "),       sizeof(mheader)-5);
-	(void) sl_strlcat(mheader, 
-			  sh_unix_time (0, timebuf, sizeof(timebuf)),
-			  sizeof(mheader)-5);
+	(void) sl_strlcat(mheader, sh_unix_time (0),     sizeof(mheader)-5);
 	(void) sl_strlcat(mheader, " ",                  sizeof(mheader)-5);
 	(void) sl_strlcat(mheader, sh.host.name,         sizeof(mheader)-5);
@@ -611,4 +880,12 @@
     else
       {
+	
+	if (message == NULL)
+	  {
+	    theMsg  = pop_list(fifo_mail);
+	    message = theMsg;
+	    if (message)
+	      --sh.mailNum.alarm_last;
+	  }
 	
 	if (message)
@@ -619,7 +896,5 @@
 	  {
 	    (void) sl_strlcpy(mheader, _("Subject: "),     sizeof(mheader)-5);
-	    (void) sl_strlcat(mheader, 
-			      sh_unix_time (0, timebuf, sizeof(timebuf)),
-			      sizeof(mheader)-5);
+	    (void) sl_strlcat(mheader, sh_unix_time (0),   sizeof(mheader)-5);
 	    (void) sl_strlcat(mheader, " ",                sizeof(mheader)-5);
 	    (void) sl_strlcat(mheader, sh.host.name,       sizeof(mheader)-5);
@@ -633,6 +908,5 @@
     /* ---------- Message  --------------------------------------- */
 
-    (void) sl_strlcpy(subject, sh_unix_time (0, timebuf, sizeof(timebuf)),
-		      sizeof(subject));
+    (void) sl_strlcpy(subject, sh_unix_time (0),          sizeof(subject));
     (void) sl_strlcat(subject, " ",                       sizeof(subject));
     (void) sl_strlcat(subject, sh.host.name,              sizeof(subject));
@@ -640,139 +914,195 @@
 
 
-    mailMsg     = sh_string_new (SH_MAILBUF);
-    compMsg     = sh_string_new (SH_MAILBUF);
-
-    mailMsg     = sh_string_add_from_char(mailMsg, mheader);
-    mailMsg     = sh_string_add_from_char(mailMsg, 
-					  _("-----BEGIN MESSAGE-----\r\n"));
-
-    mailMsg     = sh_string_add_from_char(mailMsg, subject);
-    mailMsg     = sh_string_add          (mailMsg, theMsg);
-    mailMsg     = sh_string_add_from_char(mailMsg, "\r\n");
-
-    /* ---------- Compressed Message  ---------------------------- */
-
-    compMsg     = sh_string_add_from_char(compMsg, subject);
-    compMsg     = sh_string_add          (compMsg, theMsg);
-    compMsg     = sh_string_add_from_char(compMsg, "\r\n");
-
-    bufcompress = SH_ALLOC(sh_string_len(compMsg) + KEY_LEN + 1);
+    mailMsg     = (char *) SH_ALLOC (msgbufsize);
+    bufcompress = (char *) SH_ALLOC (combufsize);
+
+    MLOCK(mailMsg     , msgbufsize);
+    MLOCK(bufcompress , combufsize);
+
+    (void) sl_strlcpy(mailMsg, mheader, msgbufsize);
     bufcompress[0] = '\0';
 
-    compressed = sh_util_compress (bufcompress, 
-				   sh_string_str(compMsg), 
-				   sh_string_len(compMsg) + 1);
+    (void) sl_strlcat(mailMsg, _("-----BEGIN MESSAGE-----\r\n"), msgbufsize);
+    (void) sl_strlcat(mailMsg, subject, msgbufsize);
+    (void) sh_util_compress (bufcompress, subject, 
+			     (combufsize - KEY_LEN - 1));
+    if (message != NULL)
+      {
+	if ((sl_strlen(theMsg) + sl_strlen(mailMsg) + 1) > 
+	    (msgbufsize-(4*KEY_LEN)))
+	  {
+	    mailMsg     = sh_mail_realloc(mailMsg,     
+					  &msgbufsize, sl_strlen(theMsg)+2);
+	    bufcompress = sh_mail_realloc(bufcompress, 
+					  &combufsize, sl_strlen(theMsg));
+	  }
+	(void) sl_strlcat(mailMsg,  theMsg, msgbufsize-(4*KEY_LEN));
+	(void) sl_strlcat(mailMsg,  "\r\n", msgbufsize-(4*KEY_LEN));
+
+	(void) sh_util_compress (bufcompress,  theMsg, combufsize-KEY_LEN-1);
+      }
+
+    if (sh.mailNum.alarm_last > 0)
+      {
+	fifo_temp = SH_ALLOC (sizeof(SH_FIFO));
+	fifo_init (fifo_temp);
+
+	while ( NULL != (popMsg = pop_list(fifo_mail)) )
+	  {
+	    (void) push_list (fifo_temp, popMsg);
+
+	    if ((sl_strlen(popMsg) + sl_strlen(mailMsg) + 1) > 
+		(msgbufsize-(4*KEY_LEN)))
+	      {
+		mailMsg     = sh_mail_realloc(mailMsg,     
+					      &msgbufsize, 
+					      sl_strlen(popMsg)+2);
+		bufcompress = sh_mail_realloc(bufcompress, 
+					      &combufsize, 
+					      sl_strlen(popMsg));
+	      }
+
+	    (void) sl_strlcat(mailMsg, popMsg, msgbufsize-(4*KEY_LEN));
+	    (void) sl_strlcat(mailMsg, "\r\n", msgbufsize-(4*KEY_LEN));
+	    (void) sh_util_compress(bufcompress, popMsg, combufsize-KEY_LEN-1);
+	    SH_FREE(popMsg);
+	    --sh.mailNum.alarm_last;
+	    ++num_popped;
+	  }
+      }
+
+    /* ------ signature block ------------------------------------ */
+    
+    (void) sl_strlcat(mailMsg, _("-----BEGIN SIGNATURE-----\r\n"), msgbufsize);
+
+    /* Generate new signature key.
+     */
+    if (isfirst == 1)
+      {
+	BREAKEXIT(sh_util_keyinit);
+	(void) sh_util_keyinit (skey->mailkey_old, KEY_LEN+1);
+      }
+
+    /* iterate the key
+     */
+    (void) sl_strlcpy(skey->mailkey_new,
+		      sh_tiger_hash (skey->mailkey_old, TIGER_DATA, KEY_LEN),
+		      KEY_LEN+1);
+
+    if (isfirst == 0)
+      {
+        /* Sign the message with the signature key.
+         */
+	theSig = sh_util_siggen (skey->mailkey_new, 
+				 bufcompress, sl_strlen(bufcompress));
+	(void) sl_strlcat (mailMsg, 
+			   theSig,
+			   msgbufsize);
+      }
+    else
+      {
+        id_audit = time (NULL);
+
+        /* reveal first signature key
+         */
+        (void) sl_strlcpy(skey->crypt, skey->mailkey_new, KEY_LEN+1);
+
+	BREAKEXIT(sh_util_encode);
+        sh_util_encode(skey->crypt, bufcompress, 0, 'A');
+
+        (void) sl_strlcat (mailMsg, skey->crypt, msgbufsize);
+        memset (skey->crypt, 0, KEY_LEN);
+        isfirst = 0;
+      }
+    (void) sl_strlcat (mailMsg, "\r\n", msgbufsize);
+
+    /* X(n) -> X(n-1)
+     */
+    (void) sl_strlcpy (skey->mailkey_old, skey->mailkey_new, KEY_LEN+1);
+
+    /*@-bufferoverflowhigh@*/
+    sprintf(subject, _("%06d %010ld::%s\r\n"),         /* known to fit  */
+            mailcount, (long) id_audit, sh.host.name);
+    /*@+bufferoverflowhigh@*/
+
+    (void) sl_strlcat (mailMsg, subject, msgbufsize);
+    ++mailcount;
+
+    (void) sl_strlcat (mailMsg, _("-----END MESSAGE-----"), msgbufsize);
+
+
 
     /* ---------- Connect ---------------------------------------- */
 
+
+
+    /* -- Catch (ignore) 'broken pipe'.
+     */
+    new_act.sa_handler = SIG_IGN;
+    sigemptyset( &new_act.sa_mask );         /* set an empty mask       */
+    new_act.sa_flags = 0;                    /* init sa_flags           */
+
+    (void) sigaction (SIGPIPE, &new_act, &old_act);
+
+    i        = 0;
     errcount = 0;
 
-    if (sh_mail_all_in_one == S_FALSE)
+    if (all_in_one == S_FALSE)
       {
-	struct alias * address_list;
-
-	address_list = all_recipients;
-
-	while (address_list)
+	while (address_list[i] != NULL && i < address_num)
 	  {
-	    if (address_list->send_mail == 1)
+	    connfile = sh_mail_start_conn (i);
+	    
+	    if (NULL != connfile)
 	      {
-		connfile = sh_mail_start_conn (address_list, 
-					       &ma_socket, &address_num);
-	    
-		if (NULL != connfile)
-		  {
-		    wrlen = fwrite (sh_string_str(mailMsg), 1, 
-				    sh_string_len(mailMsg), connfile);
-		    wrlen -= sh_string_len(mailMsg);
-
-		    if (wrlen == 0)
-		      {
-			sh_string  * sigMsg  = sh_string_new (0);
-
-			sigMsg = sh_mail_signature_block (sigMsg, 
-							  sh_string_str(address_list->recipient),
-							  bufcompress);
-
-			wrlen = fwrite (sh_string_str(sigMsg), 1, 
-					sh_string_len(sigMsg), connfile);
-			wrlen -= sh_string_len(sigMsg);
-
-			sh_string_destroy(&sigMsg);
-		      }
-
-		    if (wrlen == 0) 
-		      status = sh_mail_end_conn (connfile, ma_socket);
-		    else
-		      status = -1;
-		  }
-		if (NULL == connfile ||  status != 0)
-		  {
-		    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_SRV_FAIL,
-				     _("mail"), 
-				     sh_string_str(address_list->recipient));
-		    ++errcount;
-		    ++sh.statistics.mail_failed;
-		  }
+		wrlen = fwrite (mailMsg, 1, sl_strlen(mailMsg), 
+				 connfile);
+		wrlen -= sl_strlen(mailMsg);
+		if (wrlen == 0) 
+		  status = sh_mail_end_conn (connfile);
 		else
-		  {
-		    ++sh.statistics.mail_success;
-		  }
-		
-		if (connfile != NULL)
-		  {
-		    (void) sl_fclose (FIL__, __LINE__, connfile);
-		    connfile = NULL;
-		  }
+		  status = -1;
 	      }
-	    address_list = address_list->all_next;
+	    if (NULL == connfile ||  status != 0)
+	      {
+		ma_block = 1;
+		sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_SRV_FAIL,
+				 _("mail"), address_list[i]);
+		ma_block = 0;
+		++errcount;
+		++sh.statistics.mail_failed;
+	      }
+	    else
+	      {
+		++sh.statistics.mail_success;
+	      }
+
+	    if (connfile != NULL)
+	      {
+		(void) fclose (connfile);
+		connfile = NULL;
+	      }
+	    ++i;
 	  }
       }
     else
       {
-	connfile = sh_mail_start_conn (NULL, &ma_socket, &address_num);
-
+	connfile = sh_mail_start_conn ( -9 );
+	
 	if (NULL != connfile)
 	  {
-	    wrlen = fwrite (sh_string_str(mailMsg), 1, 
-			    sh_string_len(mailMsg), connfile);
-	    wrlen -= sh_string_len(mailMsg);
-
+	    wrlen = fwrite (mailMsg, 1, sl_strlen(mailMsg), connfile);
+	    wrlen -= sl_strlen(mailMsg);
 	    if (wrlen == 0)
-	      {
-		sh_string  * sigMsg  = sh_string_new (0);
-		
-		sigMsg  = sh_mail_signature_block (sigMsg, 
-						   NULL,
-						   bufcompress);
-		
-		wrlen = fwrite (sh_string_str(sigMsg), 1, 
-				sh_string_len(sigMsg), connfile);
-		wrlen -= sh_string_len(sigMsg);
-		
-		sh_string_destroy(&sigMsg);
-	      }
-
-	    if (wrlen == 0)
-	      status = sh_mail_end_conn (connfile, ma_socket);
+	      status = sh_mail_end_conn (connfile);
 	    else
 	      status = -1;
 	  }
-
-	if (NULL == connfile || status != 0)
+	if (NULL == connfile ||  status != 0)
 	  {
-	    struct alias* ma_address = all_recipients;
-
-	    while (ma_address)
-	      {
-		if (ma_address->send_mail == 1)
-		  break;
-		ma_address = ma_address->all_next;
-	      }
-
-	    if (ma_address)
-	      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_SRV_FAIL,
-			       _("mail"), 
-			       sh_string_str(ma_address->recipient));
+	    ma_block = 1;
+	    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_SRV_FAIL,
+			     _("mail"), address_list[0]);
+	    ma_block = 0;
 	    errcount = address_num;
 	    ++sh.statistics.mail_failed;
@@ -785,31 +1115,65 @@
 	if (connfile != NULL)
 	  {
-	    (void) sl_fclose (FIL__, __LINE__, connfile);
+	    (void) fclose (connfile);
 	    connfile = NULL;
 	  }
       }
+
     
-    memset (bufcompress, 0, compressed);
+    memset (bufcompress, 0, combufsize);
+    MUNLOCK(bufcompress , combufsize);
     SH_FREE(bufcompress);
 
-    memset (sh_string_str(mailMsg), 0, sh_string_len(mailMsg));
-    memset (sh_string_str(compMsg), 0, sh_string_len(compMsg));
-    memset (sh_string_str(theMsg),  0, sh_string_len(theMsg));
-
-    sh_string_destroy(&mailMsg);
-    sh_string_destroy(&compMsg);
-    sh_string_destroy(&theMsg);
+    memset (mailMsg, 0, msgbufsize);
+    MUNLOCK(mailMsg , msgbufsize);
+    SH_FREE(mailMsg);
 
     /* --- Stay responsible for delivery in case of failure --- */
 
-    if (errcount == address_num)
+    if (errcount == address_num && fifo_temp != NULL)
       {
-	rollback_list(fifo_mail);
-	retval = -3;
+        while ( (NULL != (popMsg = pop_list(fifo_temp))) )
+          {
+            if (push_list (fifo_mail, popMsg) >= 0)
+	      ++sh.mailNum.alarm_last;
+            SH_FREE(popMsg);
+          }
+	if (message != NULL)
+	  {
+	    if (fifo_mail == NULL)
+	      {
+		fifo_mail = SH_ALLOC(sizeof(SH_FIFO));
+		fifo_init(fifo_mail);
+	      }
+	    retval = push_list (fifo_mail,  theMsg);
+	    if (retval >= 0) 
+	      ++sh.mailNum.alarm_last;
+	    if (retval == SH_FIFO_MAX)
+	      retval = -2;
+	    else
+	      retval = -1;
+	  }
       }
-    else
+    else if (fifo_temp != NULL)
       {
-	mark_list(fifo_mail);
+        while ( (NULL != (popMsg = pop_list(fifo_temp))) )
+          {
+            SH_FREE(popMsg);
+          }
       }
+    if (fifo_temp != NULL)
+      SH_FREE(fifo_temp);
+
+    /*
+    if (connfile != NULL) 
+      fclose (connfile);
+    */
+
+    if (theMsg != NULL)
+      SH_FREE(theMsg);
+
+    /* --- Reset signal. ---
+     */
+    (void) sigaction (SIGPIPE, &old_act, NULL);
 
     if (errcount == address_num)
@@ -818,5 +1182,4 @@
 	SL_RETURN((retval), _("sh_mail_msg"));
       }
-
     success_time = time(NULL);
     failcount = 0;
